## Name

vfs_fileid — Generates file_id structs with unique device id values for cluster setups

## Synopsis

`vfs objects = fileid`

## DESCRIPTION

This VFS module is part of the samba(7) suite.

Samba uses file_id structs to uniquely identify files for locking purpose. By default the file_id contains the device and inode number returned by the `stat()` system call. As the file_id is a unique identifier of a file, it must be the same on all nodes in a cluster setup. This module overloads the `SMB_VFS_FILE_ID_CREATE()` operation and generates the device number based on the configured algorithm (see the "fileid:algorithm" option).

## OPTIONS

fileid:algorithm = ALGORITHM

  Available algorithms are `fsname` and `fsid`. The default value is `fsname`.

  The `fsname` algorithm generates device id by hashing the kernel device name.

  The `fsid` algorithm generates the device id from the `f_fsid` returned from the `statfs()` syscall.

fileid:mapping = ALGORITHM

  This option is the legacy version of the `fileid:algorithm` option, which was used in earlier versions of fileid mapping feature in custom Samba 3.0 versions.

## EXAMPLES

Usage of the `fileid` module with the `fsid` algorithm:

            [global]
    	vfs objects = fileid
    	fileid:algorithm = fsid

## VERSION

This man page is correct for version 3.2 of the Samba suite.

## AUTHOR

The original Samba software and related utilities were created by Andrew Tridgell. Samba is now developed by the Samba Team as an Open Source project similar to the way the Linux kernel is developed.